use sheepctl_core::{
    args::{DeviceCommands, SheepctlArgs, SheepctlCommand},
    cmd::{interactive_shell, list_devices, login, run_osquery},
};

mod api;
mod sheepctl_core;

fn main() {
    let args: SheepctlArgs = argh::from_env();

    match args.command {
        SheepctlCommand::Device(device_command) => match device_command.command {
            DeviceCommands::List(list_devices_command) => list_devices(list_devices_command),
        },
        SheepctlCommand::Login(login_command) => login(login_command),
        SheepctlCommand::Shell(shell_command) => interactive_shell(shell_command),
        SheepctlCommand::Query(query_command) => run_osquery(query_command),
    }
}
